package game;

import javax.faces.context.FacesContext;
import javax.servlet.http.HttpSession;
import javax.faces.application.FacesMessage;
import java.util.ResourceBundle;

public class NumberBean {

  Integer userNumber; // user entered number 
  int randomNumber ; // random number generated by application

  // constructor, generates random number
  public NumberBean () {
    randomNumber = (int)(Math.random()*100);
    System.out.println ( "Random number: "+randomNumber);
  }
  // setter for inputNumber
  public void setUserNumber (Integer value){
     this.userNumber = value;
  }
  // getter for inputNumber
  public Integer getUserNumber () {
    return this.userNumber;
  } 
  // this method simply invalidates the current session
  public String playagain () {
    FacesContext context = FacesContext.getCurrentInstance();
    HttpSession session = (HttpSession) context.getExternalContext().getSession(false);
    session.invalidate();
    return "playagain"; 
  }
  // check if user guessed the number
  public String checkGuess () {
     
    // if guessed, return 'success' for navigation
    if ( userNumber.intValue() == randomNumber ) {
      return "success";
    }
    // incorrect guess
    else {

      // get a reference to properties file to retreive messages
      FacesContext context = FacesContext.getCurrentInstance();
      ResourceBundle bundle =
                ResourceBundle.getBundle("game.messages",
                    		context.getViewRoot().getLocale());
      String msg = "";
      // if number bigger, get appropriate message
      if ( userNumber.intValue() > randomNumber ) 
         msg = bundle.getString("tryagain_smaller");
      else // if number smaller, get appropriate message
         msg = bundle.getString("tryagain_bigger");
      
      // add message to be displayed on the page via <h:messages> tag
      context.addMessage (null, new FacesMessage(msg)); 

      // return null for navigation to display the same page
      return null;
    }
  }
}